/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.Wimp;

[CCode (cheader_filename = "oslib/clipboardholder.h")]
namespace OSLib.ClipboardHolder
{
  [CCode (cname = "clipboardholderpaste_status_flags")]
  public enum ClipboardHolderPaste_StatusFlags
  {
    [CCode (cname = "clipboardholderpastestatus_DELIVERABLE_TO_MEMORY")]
    DeliverableToMemory,
    [CCode (cname = "clipboardholderpastestatus_DELIVERABLE_TO_FILE")]
    DeliverableToFile,
    [CCode (cname = "clipboardholderpastestatus_NEEDS_PROTOCOL")]
    NeedsProtocol
  }


  [CCode (cname = "xclipboardholdercopy_from_memory")]
  public static OS.Error* XClipboardHolderCopy_FromMemory
    (int filetype,
     char* src,
     int length);

  [CCode (cname = "clipboardholdercopy_from_memory")]
  public static void ClipboardHolderCopy_FromMemory
    (int filetype,
     char* src,
     int length);

  [CCode (cname = "xclipboardholdercopy_from_file")]
  public static OS.Error* XClipboardHolderCopy_FromFile
    (int filetype,
     string filename);

  [CCode (cname = "clipboardholdercopy_from_file")]
  public static void ClipboardHolderCopy_FromFile
    (int filetype,
     string filename);

  [CCode (cname = "xclipboardholderpaste_get_state")]
  public static OS.Error* XClipboardHolderPaste_GetState
    (int pref_filetype,
     out ClipboardHolderPaste_StatusFlags status,
     out int filetype);

  [CCode (cname = "clipboardholderpaste_get_state")]
  public static ClipboardHolderPaste_StatusFlags ClipboardHolderPaste_GetState
    (int pref_filetype,
     out int filetype);

  [CCode (cname = "xclipboardholderpaste_to_memory")]
  public static OS.Error* XClipboardHolderPaste_ToMemory
    (int pref_filetype,
     Wimp.W window_handle,
     int handle,
     out ClipboardHolderPaste_StatusFlags status,
     out int filetype,
     out char* src,
     out int length);

  [CCode (cname = "clipboardholderpaste_to_memory")]
  public static ClipboardHolderPaste_StatusFlags ClipboardHolderPaste_ToMemory
    (int pref_filetype,
     Wimp.W window_handle,
     int handle,
     out int filetype,
     out char* src,
     out int length);

  [CCode (cname = "xclipboardholderpaste_to_file")]
  public static OS.Error* XClipboardHolderPaste_ToFile
    (int pref_filetype,
     Wimp.W window_handle,
     int handle,
     out ClipboardHolderPaste_StatusFlags status,
     out int filetype,
     out string filename);

  [CCode (cname = "clipboardholderpaste_to_file")]
  public static ClipboardHolderPaste_StatusFlags ClipboardHolderPaste_ToFile
    (int pref_filetype,
     Wimp.W window_handle,
     int handle,
     out int filetype,
     out string filename);

}
