/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;

[CCode (cheader_filename = "oslib/keyinput.h")]
namespace OSLib.KeyInput
{
  [CCode (cname = "keyinputcheck_flags")]
  public enum KeyInputCheck_Flags
  {
    Default = 0
  }

  [CCode (cname = "keyinputcheckmultiple_flags")]
  public enum KeyInputCheckMultiple_Flags
  {
    [CCode (cname = "keyinputcheckmultipleflags_RETURN_TIME")]
    ReturnTime
  }

  [CCode (cname = "keyinputscan_flags")]
  public enum KeyInputScan_Flags
  {
    Default = 0
  }

  [CCode (cname = "keyinputscanmultiple_flags")]
  public enum KeyInputScanMultiple_Flags
  {
    [CCode (cname = "keyinputscanmultipleflags_RETURN_TIME")]
    ReturnTime
  }


  [CCode (cname = "xkeyinput_check")]
  public static OS.Error* XCheck
    (KeyInputCheck_Flags flags,
     int usage,
     out int state,
     out int time);

  [CCode (cname = "keyinput_check")]
  public static void Check
    (KeyInputCheck_Flags flags,
     int usage,
     out int state,
     out int time);

  [CCode (cname = "xkeyinput_check_multiple")]
  public static OS.Error* XCheckMultiple
    (KeyInputCheckMultiple_Flags flags,
     int* buf,
     int num_entries_to_fill,
     out int num_entries_filled);

  [CCode (cname = "keyinput_check_multiple")]
  public static void CheckMultiple
    (KeyInputCheckMultiple_Flags flags,
     int* buf,
     int num_entries_to_fill,
     out int num_entries_filled);

  [CCode (cname = "xkeyinput_scan")]
  public static OS.Error* XScan
    (KeyInputScan_Flags flags,
     int initial_code,
     out int next_code,
     out int state,
     out int time);

  [CCode (cname = "keyinput_scan")]
  public static void Scan
    (KeyInputScan_Flags flags,
     int initial_code,
     out int next_code,
     out int state,
     out int time);

  [CCode (cname = "xkeyinput_scan_multiple")]
  public static OS.Error* XScanMultiple
    (KeyInputScanMultiple_Flags flags,
     int initial_code,
     int* buf,
     int num_entries_to_fill,
     out int next_code,
     out int num_entries_filled);

  [CCode (cname = "keyinput_scan_multiple")]
  public static void ScanMultiple
    (KeyInputScanMultiple_Flags flags,
     int initial_code,
     int* buf,
     int num_entries_to_fill,
     out int next_code,
     out int num_entries_filled);

}
