/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;

[CCode (cheader_filename = "oslib/pathutils.h")]
namespace OSLib.PathUtils
{
  [CCode (cname = "pathutilsenumeratepath_flags")]
  public enum PathUtilsEnumeratePath_Flags
  {
    Default = 0
  }

  [CCode (cname = "pathutilsjoinpath_flags")]
  public enum PathUtilsJoinPath_Flags
  {
    Default = 0
  }

  [CCode (cname = "pathutilsremovepath_flags")]
  public enum PathUtilsRemovePath_Flags
  {
    Default = 0
  }


  [CCode (cname = "xpathutils_enumerate_path")]
  public static OS.Error* XEnumeratePath
    (PathUtilsEnumeratePath_Flags flags,
     string path,
     string output_buf,
     int output_buf_size,
     int context,
     out int spare_bytes,
     out int new_context,
     out OS.VarType var_type,
     out int depth);

  [CCode (cname = "pathutils_enumerate_path")]
  public static void EnumeratePath
    (PathUtilsEnumeratePath_Flags flags,
     string path,
     string output_buf,
     int output_buf_size,
     int context,
     out int spare_bytes,
     out int new_context,
     out OS.VarType var_type,
     out int depth);

  [CCode (cname = "xpathutils_join_path")]
  public static OS.Error* XJoinPath
    (PathUtilsJoinPath_Flags flags,
     string path_var_name,
     string value_to_join);

  [CCode (cname = "pathutils_join_path")]
  public static void JoinPath
    (PathUtilsJoinPath_Flags flags,
     string path_var_name,
     string value_to_join);

  [CCode (cname = "xpathutils_remove_path")]
  public static OS.Error* XRemovePath
    (PathUtilsRemovePath_Flags flags,
     string path_var_name,
     string value_to_remove);

  [CCode (cname = "pathutils_remove_path")]
  public static void RemovePath
    (PathUtilsRemovePath_Flags flags,
     string path_var_name,
     string value_to_remove);

}
